﻿(function () {
    var app = angular.module('chat-app', []);

    app.controller('ChatContoller', function ($scope) {
        // scope variables
        $scope.name = 'Guest'; // holds the user's name
        $scope.message = ''; // holds the new message
        $scope.messages = []; // collection of messages coming from server
        $scope.chatHub = null; // holds the reference to hub

        var connection = $.hubConnection();

        //$scope.chatHub = $.connection.chatHub; // initializes hub
        $scope.chatHub = connection.createHubProxy('chatHub');

        //$.connection.hub.start(); // starts hub
        connection.start(); // starts hub

        // register a client method on hub to be invoked by the server
        //$scope.chatHub.client.broadcastMessage = function (name, message) {
        $scope.chatHub.on('broadcastMessage', function (name, message) {
            var newMessage = name + ' says: ' + message;

            // push the newly coming message to the collection of messages
            $scope.messages.push(newMessage);
            $scope.$apply();
        });

        $scope.newMessage = function () {
            // sends a new message to the server
            //$scope.chatHub.server.sendMessage($scope.name, $scope.message);
            $scope.chatHub.invoke('sendMessage', $scope.name, $scope.message);

            $scope.message = '';
        }
    })
}());